config/routes.rb
Rails.application.routes.draw do
  
  get 'events/manage_event' => 'events#manage_event'
  devise_for :users
  resources :events

   root 'events#index'

end

app/models/concerns/general_query.rb
module GeneralQuery

  def get_date_format(date)
    date.strftime("#{date.day.ordinalize} %b %y")
  end

  def event_valid(date)
  	(Date.today  <= date == true) ? ENABLE : DISABLE
  end
  
end

app/models/event.rb
class Event < ActiveRecord::Base
	has_and_belongs_to_many :users
	mount_uploader :avatar, AvatarUploader

    extend GeneralQuery

    validates :name, presence: { message: "Event Name can't be blank"}, length: { maximum: 100, message: "Event Name can't be greater than 100 character" }
    validates :description, presence: { message: "Event Description can't be blank" }, length: { maximum: 1000, message: "Event Description can't be greater than 1000 character" }
    validates :address, presence: {message: "Address can't be blank"}, length: { maximum: 1000, message: "Address can't be greater than 1000 character" }
    validates :start_date, presence: { message: "Event Start date can't be blank"}
    validates :end_date, presence: { message: "Event End date can't be blank"}
    validates :contact_email, format: { with: EMAIL_REGEX, message: "Wrong Email Id"}
    validates :contact_no, format: { with: PHONE_NUMBER_REGEX, message: "Wrong Contact No Number", :multiline => true }, length: { maximum: 11, message: "Phone Number can't be greater than 11 character" }


	def self.get_event_detail(user)

		Event.order(created_at: :desc).map{|h| {id: h.id, name: h.name, start_date: get_date_format(h.start_date),\
		end_date: get_date_format(h.end_date), fees: h.fees, created_by_id: h.created_by, created_by: (User.find_by_id(h.created_by).name if User.find_by_id(h.created_by)),\
		contact_email: h.contact_email, contact_no: h.contact_no, status: (user.present? and h.created_by == user.id ? ENABLE : DISABLE ),\
		event_valid: event_valid(h.start_date), attend: (user.present? ? (h.users.include?(user) == true ?  ENABLE : DISABLE): DISABLE)}}

	end

	def get_user_name
		self.users.map{|h| {email: h.email, name: h.name, gender: h.gender.titleize, fees: self.fees}}
	end

	def get_name
		User.find_by_id(self.created_by).name
	end
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
  has_and_belongs_to_many :events       

  validates :name, presence: { message: "User Name can't be blank"}, length: { maximum: 100, message: "User Name can't be greater than 100 character" }
  validates :gender, presence: { message: "Gender can't be blank"}
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception
  before_action :configure_permitted_parameters, if: :devise_controller?
  
 protected
  def configure_permitted_parameters
   devise_parameter_sanitizer.permit(:sign_up) { |u| u.permit(:email, :password, :confirm_password, :name, :gender) }
  end
end

app/controllers/events_controller.rb
class EventsController < ApplicationController
  
  before_action :authenticate_user!, except: [:index, :show]
  before_action :set_event, only: [:show, :edit, :update, :destroy, :manage_event]

  # GET /events
  # GET /events.json
  def index
    @events = Event.get_event_detail(current_user)
  end

  # GET /events/1
  # GET /events/1.json
  def show
    @users = @event.get_user_name
  end

  # GET /events/new
  def new
    @event = Event.new
  end

  # GET /events/1/edit
  def edit
  end

  # POST /events
  # POST /events.json
  def create

    @event = Event.new(event_params)

    respond_to do |format|
      if @event.save and current_user.events << @event
        format.html { redirect_to @event, notice: 'Event was successfully created.' }
        format.json { render :show, status: :created, location: @event }
      else
        format.html { render :new }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /events/1
  # PATCH/PUT /events/1.json
  def update
    respond_to do |format|
      if @event.update(event_params)
        format.html { redirect_to @event, notice: 'Event was successfully updated.' }
        format.json { render :show, status: :ok, location: @event }
      else
        format.html { render :edit }
        format.json { render json: @event.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /events/1
  # DELETE /events/1.json
  def destroy
    @event.destroy
    respond_to do |format|
      format.html { redirect_to events_url, notice: 'Event was successfully destroyed.' }
      format.json { head :no_content }
    end
  end


  def manage_event
    if params[:value] == "1"
    @event.users << current_user
    else
      @event.users.delete(User.find_by_id current_user.id)
    end
    render :nothing => true 
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_event
      @event = Event.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def event_params
      params.require(:event).permit(:name, :description, :address, :start_date, :end_date, :contact_email, :contact_no, :fees, :created_by, :avatar)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper

 def show_errors(error,field)
    error.messages[field].join(', ') if error.present? && !error.messages[field].nil?
 end


  def get_consession_price(price)
  	(0.95)*price.to_f
  end
end

app/helpers/events_helper.rb
module EventsHelper
end

app/views/events/_form.html.erb
<% errors = @event.errors %>
<%= form_for(@event, html: { class: 'form-horizontal', role: 'form' }) do |f| %>
    <div class="form-group">
      <label class="control-label col-sm-2" for="name">Name:</label>
      <div class="col-sm-6">
        <%= f.text_field :name, class: 'form-control', id: 'name', placeholder: 'Enter name' %>
      <div class="field-error"><%= show_errors(errors,:name)%></div>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="description">Description:</label>
      <div class="col-sm-6">
        <%= f.text_area :description, class: 'form-control', id: 'description', placeholder: 'Enter description' %>
     <div class="field-error"><%= show_errors(errors,:description)%></div>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="address">Address:</label>
      <div class="col-sm-6">
        <%= f.text_field :address, class: 'form-control', id: 'specification', placeholder: 'Enter address' %>
        <div class="field-error"><%= show_errors(errors,:address)%></div>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="start_date">Start Date:</label>
      <div class="col-sm-6">
     
        <%= f.text_field :start_date, class: 'form-control datepicker', id: 'start_date', placeholder: 'Select Start Date', readonly: true %>
     
        
        <div class="field-error"><%= show_errors(errors,:start_date)%></div>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="end_date">End Date:</label>
      <div class="col-sm-6">
      
        <%= f.text_field :end_date, class: 'form-control datepicker', id: 'end_date', placeholder: 'Select End Date', readonly: true %>
       
        <div class="field-error"><%= show_errors(errors, :end_date)%></div>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="fees">Fees:</label>
      <div class="col-sm-6">
        <%= f.text_field :fees, class: 'form-control', id: 'fees', placeholder: 'Enter fees' %>
      <div class="field-error"><%= show_errors(errors,:fees)%></div>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="contact_email">Contact Email:</label>
      <div class="col-sm-6">
        <%= f.text_field :contact_email, class: 'form-control', id: 'contact_email', placeholder: 'Enter contact email' %>
      <div class="field-error"><%= show_errors(errors,:contact_email)%></div>
      </div>
    </div>
       <div class="form-group">
      <label class="control-label col-sm-2" for="contact_no">Contact No:</label>
      <div class="col-sm-6">
        <%= f.text_field :contact_no, class: 'form-control', id: 'contact_no', placeholder: 'Enter contact no' %>
      <div class="field-error"><%= show_errors(errors,:contact_no)%></div>
      </div>
    </div>

    <div class="form-group">
    <label class="control-label col-sm-2" for="name">File:</label>
    <div class="col-sm-6">
      <%= f.file_field :avatar, class: 'form-control imageFileField' %>
    </div>
  </div>
   <%= f.hidden_field :created_by, value: current_user.id%>
    <div class="form-group">
      <div class="col-sm-offset-2 col-sm-6" align="center">
        <%= f.submit "Event", class: 'btn btn-primary' %>
      
      </div>
    </div>
<% end %>
<script type="text/javascript">



  $('.datepicker').datepicker({
    format: 'yyyy-mm-dd',
    startDate : '-3d',
    autoclose : true
  });

</script>

app/views/events/edit.html.erb
<h1>Editing Event</h1>

<%= render 'form' %>

<%= link_to 'Show', @event %> |
<%= link_to 'Back', events_path %>

app/views/events/index.html.erb
<div class="table-responsive">
  <table class="table table-hover table-bordered data-table">
    <thead>
    <tr class="black-white">
      <th class="text-align-center">Name</th> 
      <th class="text-align-center">Start Date</th>
      <th class="text-align-center">End Date</th>
      <th class="text-align-center">Fees</th>
      <%if current_user and current_user.gender == FEMALE%>
      <th class="text-align-center">Consession Fees</th>
      <%end%> 
      <th class="text-align-center">Created By</th>
      <th class="text-align-center">Contact Email</th>
      <th class="text-align-center">Contact No</th>
      <th class="text-align-center">Attend/Unattend</th>
      <th class="text-align-center">Edit</th>
      <th class="text-align-center">Delete</th>
      <!--<th colspan="3"></th>-->
    </tr>
    </thead>
    <tbody>
    <tr>
      <% @events.each do |event| %>
        <tr class="<%= cycle("cycle-1", "cycle-2") -%>" align="center">
          <td><%= link_to event[:name], event_path(event[:id]) %></td>
          <td><%= event[:start_date] %></td>
          <td><%= event[:end_date] %></td>
          <td ><%= event[:fees] %></td>
          <%if current_user and current_user.gender == FEMALE%>
          <td ><b><%= get_consession_price(event[:fees])%></b></td>
          <%end%> 
          <td><%= event[:created_by] %></td>
          <td><%= event[:contact_email] %></td>
          <td><%= event[:contact_no] %></td>
          <% if current_user.present?%>
          <td>
          <% if event[:event_valid] == ENABLE%>
              <%= select_tag :manage, options_for_select(MANAGE_EVENT, event[:attend]), id: event[:id], class: "mange_event" %>
          <%else%>
             <label>EVENT_OVER</label>
          <%end%>
          </td>
          <% if current_user and current_user.id == event[:created_by_id] and event[:event_valid] == ENABLE%>
          <td>
            <%= link_to edit_event_path(event[:id]), class: 'btn btn-default btn-sm btn btn-warning' do %>
                <span class="glyphicon glyphicon-edit"></span>
            <% end %>
          </td>
          <td>
            <%= link_to 'Destroy', event_path(event[:id]), method: :delete, data: { confirm: 'Are you sure?' }, class: 'btn btn-default btn-sm btn btn-danger'%>

          </td>
          <%else%>
          <td>-</td>
          <td>-</td>
          <%end%>
          <%else%>
           <td>-</td>
           <td>-</td>
           <td>-</td>
          <%end%>
        </tr>
    <% end %>
    </tr>
    </tbody>
  </table>
</div>
<% if current_user.present? %>
<%= link_to 'Create Event', new_event_path, class: 'btn btn-default btn-sm btn btn-primary'  %>
<%end%>

<script type="text/javascript">
  $('.mange_event').change(function(){
     val = $(this).val()
     event_id = $(this).attr('id')
     curent_select = $(this)
     $.ajax({
      async : true,
      type : 'GET',
      datatype: "JSON",
      url : "/events/manage_event",
      data : { "id": event_id,
               "value": val},         
      success: function(resp){
      },errors: function(resp){ 
                alert(resp)
      }
       
    });
  });
</script>

app/views/events/new.html.erb
<h1>New Event</h1>

<%= render 'form' %>

<%= link_to 'Back', events_path %>

app/views/events/show.html.erb
<%= form_for(@event, html: { class: 'form-horizontal', role: 'form' }) do |f| %>
    <div class="form-group">
      <label class="control-label col-sm-2" for="name">Name:</label>
      <div class="col-sm-6">
        <%= f.text_field :name, class: 'form-control', id: 'name', placeholder: 'Enter name', readonly: true %>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="description">Description:</label>
      <div class="col-sm-6">
        <%= f.text_area :description, class: 'form-control', id: 'description', placeholder: 'Enter description', readonly: true %>
    
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="address">Address:</label>
      <div class="col-sm-6">
        <%= f.text_field :address, class: 'form-control', id: 'specification', placeholder: 'Enter address', readonly: true %>
        
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="start_date">Start Date:</label>
      <div class="col-sm-6">
     
        <%= f.text_field :start_date, class: 'form-control ', id: 'start_date', placeholder: 'Select Start Date',  readonly: true%>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="end_date">End Date:</label>
      <div class="col-sm-6">
      
        <%= f.text_field :end_date, class: 'form-control ', id: 'end_date', placeholder: 'Select End Date', readonly: true, readonly: true %>
      </div>
    </div>
    <div class="form-group">
      <label class="control-label col-sm-2" for="fees">Fees:</label>
      <div class="col-sm-6">
        <%= f.text_field :fees, class: 'form-control', id: 'fees', placeholder: 'Enter fees', readonly: true %>   
      </div>
    </div>
    <%if current_user and current_user.gender == FEMALE%>
     <div class="form-group">
      <label class="control-label col-sm-2" for="fees">Consession Fees:</label>
      <div class="col-sm-6">
      <b>
        <%= text_field_tag :fees, get_consession_price(@event.fees), class: 'form-control', id: 'fees', placeholder: 'Enter fees', readonly: true %>    
      </b>
      </div>
    </div>
    <%end%>
    <div class="form-group">
      <label class="control-label col-sm-2" for="contact_email">Contact Email:</label>
      <div class="col-sm-6">
        <%= f.text_field :contact_email, class: 'form-control', id: 'contact_email', placeholder: 'Enter contact email', readonly: true %>
      
      </div>
    </div>
       <div class="form-group">
      <label class="control-label col-sm-2" for="contact_no">Contact No:</label>
      <div class="col-sm-6">
        <%= f.text_field :contact_no, class: 'form-control', id: 'contact_no', placeholder: 'Enter contact no', readonly: true %>
      </div>
    </div>

    <div class="form-group">
    <label class="control-label col-sm-2" for="name">Image:</label>
    <div class="col-sm-6">
      <%= image_tag @event.avatar.url(:thumb)%>
    </div>
  </div>
  
    <div class="form-group">
    <label class="control-label col-sm-2" for="name">Created By:</label>
    <div class="col-sm-6">
      <%= text_field_tag :name, @event.get_name, class: 'form-control', readonly: true%>
    </div>
  </div>

  <div class="table-responsive">
  <table class="table table-hover table-bordered data-table">
    <thead>
    <tr class="black-white">
      <th class="text-align-center">Name</th> 
      <th class="text-align-center">Gender</th>
      <th class="text-align-center">Fees</th>
      <th class="text-align-center">Email</th>
    </tr>
    </thead>
    <tbody>
    <tr>
     <% @users.each do |k|%>
      <tr class="<%= cycle("cycle-1", "cycle-2") %>" align="center">
        <td><%= k[:name] %></td>
        <td><%= k[:gender]%></td>
        <td><%= k[:gender] == MALE.titleize ? k[:fees] : get_consession_price(k[:fees])%></td>
        <td><%= k[:email]%></td>
      </tr>
     <%end%>
    </tr>
    </tbody>
  </table>
</div>



<% end %>

 <% if current_user and current_user.id == @event.created_by%>
 <%= link_to "Edit", edit_event_path(@event), class: 'btn btn-default btn-sm btn btn-warning'  %>
 <%end%>    
 
<%= link_to 'Back', events_path, class: 'btn btn-default btn-sm btn btn-default' %>

app/views/layouts/_common_messages.html.erb
<% if notice %>
    <p class="notice alert alert-info"><%= notice %></p>
<% end %>
<% if alert %>
    <p class="alert alert-danger"><%= alert %></p>
<% end %>

app/views/layouts/_devise_messages.html.erb
<% if defined?(resource) and resource.errors.present? %>
    <div class="panel panel-danger">
      <div class="panel-heading">List of errors</div>
      <div class="panel-body">
        <ul>
          <% resource.errors.full_messages.each do |em| %>
              <li><%= em  %></li>
          <% end %>
        </ul>
      </div>
    </div>
<% end %>

<%= render partial: 'layouts/common_messages' %>

app/views/layouts/_header.html.erb
<nav class="navbar navbar-default" role="navigation">
  <!-- Brand and toggle get grouped for better mobile display -->
  <div class="navbar-header">
    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-ex1-collapse">
      <span class="sr-only">Toggle navigation</span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
    </button>
    <%= link_to "Event", events_path, class: "navbar-brand"%>
  </div>

  <!-- Collect the nav links, forms, and other content for toggling -->
  <div class="collapse navbar-collapse navbar-ex1-collapse">


    <ul class="nav navbar-nav navbar-right">
      <!--<li><a href="#">Link</a></li>-->
      <li class="dropdown">
        <% if current_user.present? %>
          <%= link_to 'Logout', destroy_user_session_path, method: :delete %>
        <%else%>
          <%= link_to "Sign In/ Sign Up", new_user_session_path%>
        <%end%>
      </li>
    </ul>
  </div>
  <!-- /.navbar-collapse -->
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>EventTickiting</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <%= csrf_meta_tags %>
</head>
<body>
    <div class="container">
      <br />
        
            <%= render partial: 'layouts/header' %>
            <%= render partial: 'layouts/common_messages' %>
       

        <%= yield %>
    </div>
</body>
</html>